'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Model = undefined;

var _nodeFetch = require('node-fetch');

var _nodeFetch2 = _interopRequireDefault(_nodeFetch);

var _formData = require('form-data');

var _formData2 = _interopRequireDefault(_formData);

var _client = require('./client');

var _client2 = _interopRequireDefault(_client);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_client2.default.setOptions({ fetch: _nodeFetch2.default, FormData: _formData2.default }); /* eslint no-use-before-define:0 */

var create = _client2.default.create;
var resolve = _client2.default.resolve;

function newCreate(options) {
  options = options || {};
  /* istanbul ignore else */
  if (!options.fetch) {
    options.fetch = _nodeFetch2.default;
  }
  /* istanbul ignore else */
  if (!options.FormData) {
    options.FormData = _formData2.default;
  }
  var client = create(options);
  client.create = newCreate;
  client.resolve = newResolve;
  return client;
}

function newResolve(key) {
  var client = resolve(key);
  /* istanbul ignore else */
  if (!client._count) {
    // 还未发送请求，新实例
    /* istanbul ignore else */
    if (!client._options.fetch) {
      client.setOptions({ fetch: _nodeFetch2.default });
    }
    /* istanbul ignore else */
    if (!client._options.FormData) {
      // 还未发送请求，新实例
      client.setOptions({ FormData: _formData2.default });
    }
  }
  client.create = newCreate;
  client.resolve = newResolve;
  return client;
}

_client2.default.create = newCreate;
_client2.default.resolve = newResolve;

exports.default = _client2.default;
exports.Model = _client.Model;